/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *  ץå¸⥸塼 ֥ARMv6-Mѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "arm_m.h"
#include "offset.h"
#include "target_asm.inc"

#if __TARGET_ARCH_THUMB != 3
#error The core_support.S support ARMv6-M only.
#endif /* __TARGET_ARCH_THUMB != 3 */

/*
 *  ǥѥå
 */
	ATEXT
	ABALIGN(4)
	ATHUMB(dispatch)
	AGLOBAL(dispatch)
ALABEL(dispatch)
	/*
	 *
	 *  Υ롼ϡƥȡCPUå֡ǥѥåľ
	 *  ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ롥
	 */
	mov  r0, r8                  /* 쥸¸ */
	mov  r1, r9
	mov  r2, r10
	mov  r3, r11
	push {r0-r7,lr}
	ldr  r0, =p_runtsk           /* p_runtskɤ߹ */
	ldr  r1, [r0]
	mov  r2, sp
	str  r2, [r1,#TCB_sp]        /* å¸ */
	ldr  r3, =dispatch_r         /* ¹ԺƳϤ¸ */
	str  r3, [r1,#TCB_pc]        
	b    dispatcher

	ATHUMB(dispatch_r)
	AGLOBAL(dispatch_r)
ALABEL(dispatch_r)
	pop  {r0-r7}                 /* 쥸 */
	mov  r8,  r0
	mov  r9,  r1
	mov  r10, r2
	mov  r11, r3
	/*
	 * 㳰롼εư
	 */
	ldr  r0, =p_runtsk           /* p_runtskɤ߹ */
	ldr  r1, [r0]
	ldrb r0, [r1,#TCB_enatex]
	movs r2, #TCB_enatex_mask
	tst  r0, r2
	beq  dispatch_r_1            /* enatex  false ʤ꥿ */
	ldr  r0, [r1,#TCB_texptn]    /* texptn  0 ʤ꥿     */
	tst  r0, r0
	beq  dispatch_r_1            
	ldr  r1, =ipmflg             /* ipmflg false ʤ꥿  */
	ldr  r0, [r1]
	tst  r0, r0
	beq  dispatch_r_1
	ldr  r0, =call_texrtn        /* 㳰롼θƤӽФ */
	bx   r0
ALABEL(dispatch_r_1)             /* ؤcall_textn */
	pop  {pc}

/*
 *  CPU㳰ȥ
 *
 *  ߥȥȽƤƱμबۤʤ뤿ᡤ
 *  ʬƤ롥
 */
	ABALIGN(4)
	ATEXT
	ATHUMB(core_exc_entry)
	AGLOBAL(core_exc_entry)
ALABEL(core_exc_entry)
	/*
	 *  㳰/ߤȯȡȯ˥ƥ֤ʥå˥
	 *  å쥸¸롥
	 *  Ƥ˲äơCPU㳰ϥɥؤξȤơbasepri ͤȡ
	 *  EXC_RETURNξä¸롥basepriͤϡCPU㳰
	 *  ꥿˳ͥ٥ޥͤ򸵤᤹ˤѤ롥
	 *
	 *   -----------
	 *  |   iipm    |
	 *   -----------
	 *  | EXC_RETURN|
	 *   -----------
	 *  |    R0     |  
	 *   -----------
	 *  |    R1     |
	 *   -----------
	 *  |    R2     |
	 *   -----------
	 *  |    R3     |
	 *   -----------
	 *  |    R12    |
	 *   -----------
	 *  |    LR     |
	 *   -----------
	 *  |    PC     |
	 *   -----------
	 *  |   xPSR    |
	 *   -----------
	 *
	 */

	/*
	 *  ͥ㳰å
	 *  ͥΥƥ륻μ¹桤ߥå֡
	 *  CPUå֡ͥγߥϥɥ¹Τ줫
	 *  ȯCPU㳰򡤥ͥCPU㳰ȸƤ
	 *  ߥå֤FAULTMASK'1'ξ
	 *  CPUå֤basepriIIPM_LOCKȽǤ롥
	 */
	ldr   r3, =iipm               /* ǻѤ뤿ɤ߹ */
	ldrb  r0, [r3]
	mrs   r2, primask             /* CPUå֤ʤ饫ͥ㳰 */
	cmp   r1, #1
	beq   core_nonkernel_exc_entry

	/*
	 * åѹɬפ뤫å
	 * EXC_RETURNʳ߻LRꤵ͡ˤåơ㳰ȯ
	 * ƥ֤ʥåꤹ뤳Ȥ¿ųߤȽꤹ롥
	 */
	movs  r1, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	mov   r2, lr
	tst   r2, r1
	beq   core_exc_entry_1       /* ¿ųߤʤcore_exc_entry_1 */
	mrs   r3, psp                /* ܤγߤξPSP */
	subs  r3, #(0x04*2)          /* ȯγͥ٥ޥ(r2)EXC_RETURN(r0)νPSPѤ */
	str   r2, [r3, 0x04]
	str   r0, [r3, 0x00]
	msr   psp, r3
	push  {r0, r2}               /* MSPˤȯγͥ٥ޥ(r0)EXC_RETURN(r2)Ѥ */
	mov   lr, r3                 /* ̤γߤȯξȤ */
	b     core_exc_entry_2
ALABEL(core_exc_entry_1)         /* ¿ųߤξ */
	push  {r0,r2}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(r2)νPSPѤ */
	mov   lr, sp                 /* CPU㳰ϥɥؤΰȤʤ */

	/*
	 *  ̽
	 */
ALABEL(core_exc_entry_2)
	/*
	 *  CPU㳰꥿󤹤ݤ˳ͥ٥ޥ᤹Υǡ¸
	 */
	ldr  r3, =SYSTIC_CONTROL_STATUS
	ldr  r2,[r3] 
	ldr  r3, =NVIC_SETENA0
	ldr  r1,[r3] 
	push {r1,r2}

	mrs   r3, ipsr               /* ϥɥ饢ɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	lsls  r0, r3, #2
	ldr   r2, [r1, r0]

#ifdef LOG_EXC_ENTER
	push  {r0,r2,r3}
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_exc_enter          /* log_exc_enterƤӽФ */
	pop   {r0,r2,r3}
	push  {r3}                   /* 㳰ֹ򥹥å    */
#endif /* LOG_EXC_ENTER */

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	mov   r0, lr
	blx   r2

#ifdef LOG_EXC_ENTER
	pop   {r0}                   /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_ENTER */

	b     ret_exc

/*
 *  ͥCPU㳰ν
 */
ALABEL(core_nonkernel_exc_entry)
	movs  r1, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	mov   r2, lr
	tst   r2, r1
	beq   core_nonkernel_exc_entry_1  /* ¿ųߤʤ */
	mrs   r3, psp                /* ܤγߤξPSP */
	subs  r3, #(0x04*2)
	str   r2, [r3, 0x04]
	str   r0, [r3, 0x00]
	msr   psp, r3                
	push  {r0, r2}               /* MSPˤȯγͥ٥ޥ(r0)EXC_RETURN(r2)Ѥ */
	mov   r0,  r3                /* CPU㳰ϥɥؤΰȤʤ */
	b     core_nonkernel_exc_entry_2
ALABEL(core_nonkernel_exc_entry_1) /* ¿ųߤξ */
	push  {r0, r2}               /* ȯγͥ٥ޥ(r0)EXC_RETURN(r2)Ѥ */
	mov   r0, sp                 /* CPU㳰ϥɥؤΰȤʤ */

	/*
	 *  ̽
	 */
ALABEL(core_nonkernel_exc_entry_2)
	/*
	 *  ߤ꥿󤹤ݤ˳ͥ٥ޥ᤹Υǡ¸
	 */
	ldr  r3, =SYSTIC_CONTROL_STATUS
	ldr  r2,[r3] 
	ldr  r3, =NVIC_SETENA0
	ldr  r1,[r3] 
	push {r1,r2}

	mrs   r3, ipsr               /* CPU㳰ϥɥΥɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	lsls  r4, r3, #2
	ldr   r2, [r1, r4]

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	blx   r2

	/*
	 *  CPUå֤ξ˸ƤӽФƤ뤿ᡤCPU㳰ϥɥ餫Υ꥿
	 *  Τ˸᤹
	 */
	cpsid i

	/*
	 *  ͥ٥ޥ򸵤᤹
	 */
	ldr  r1, =0xffffffff
	ldr  r2, =NVIC_CLRENA0  /* öIRQߤƶػ */
	str  r1, [r2]
	pop  {r0,r1}            /* å㳰ȯNVIC_SETENA0(r0),SYSTIC_CONTROL_STATUS(r1)ͤ */
	ldr  r2, =NVIC_SETENA0  /* NVIC_SETENA0򸵤᤹ */
	str  r0, [r2]
	ldr  r3, =SYSTIC_CONTROL_STATUS  /* SYSTIC_CONTROL_STATUS򸵤᤹ */
	ldr  r0,[r3] 
	movs r2, #SYSTIC_TICINT
	orrs r1, r1, r2
	bics r0, r2
	orrs r0, r1
	str  r0, [r3]
	pop  {r0}               /* iipm᤹ */
	ldr  r1, =iipm
	strb r0, [r1]

	/*
	 *  ΥƥȤȽ
	 * 
	 *  ߥϥɥ¹ԤLR˥åȤEXC_RETURNåơ
	 *  MSPȤƤС褬󥿥ƥȤȽꤹ롥
	 */
	pop   {r3}                   /* lr򥹥å        */
	movs  r1, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	tst   r3, r1
	bne   core_nonkernel_ret_exc_1
	b     core_nonkernel_ret_exc_2 /* ͤMSP */
ALABEL(core_nonkernel_ret_exc_1)
	/*
	 *  PSP夫EXC_RETURN/γͥ٥ޥ(iipm)
	 */
	mrs   r2, psp
	adds  r2, r2, #8
	msr   psp, r2

ALABEL(core_nonkernel_ret_exc_2)
	bx    r3                      /* ꥿ */

/*
 *  ߥȥ
 */
	ATHUMB(core_int_entry)
	AGLOBAL(core_int_entry)
ALABEL(core_int_entry)
	/*
	 *  ȯγͥ٥ޥ򥹥å¸뤿
	 */
	ldr   r3, =iipm               /* ǻѤ뤿ɤ߹ */
	ldrb  r0, [r3]

	/*
	 * ¿ųߤå
	 * EXC_RETURNʳ߻LRꤵ͡ˤåơ㳰ȯ
	 * ƥ֤ʥåꤹ뤳Ȥ¿ųߤȽꤹ롥
	 */
	movs  r1, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	mov   r2, lr
	tst   r2, r1
	beq   core_int_entry_1       /* ¿ųߤʤcore_int_entry_1 */
	mrs   r3, psp                /* ܤγߤξPSP */
	subs  r3, #(0x04*2)
	str   r2, [r3, 0x04]
	str   r0, [r3, 0x00]
	msr   psp, r3
	push  {r0, r2}               /* MSPˤȯγͥ٥ޥ(r0)EXC_RETURN(r2)Ѥ */
	mov   lr, r3                 /* ̤γߤȯξȤ */
	b     core_int_entry_2
ALABEL(core_int_entry_1)         /* ¿ųߤξ */
	push  {r0, r2}               /* ȯγͥ٥ޥ(r0)EXC_RETURN(r2)Ѥ */
	mov   lr, sp                 /* ̤γߤȯξȤ */

	/*
	 *  ̽
	 */
ALABEL(core_int_entry_2)
	/*
	 *  ߤ꥿󤹤ݤ˳ͥ٥ޥ᤹Υǡ¸
	 */
	ldr  r3, =SYSTIC_CONTROL_STATUS
	ldr  r2,[r3] 
	ldr  r3, =NVIC_SETENA0
	ldr  r1,[r3] 
	push {r1,r2}

	mrs   r3, ipsr   /* װֹμ */

	/*
	 *  basepri
	 *  NVICͥ٥ޥưŪꤵ뤿ͥ٥ޥǤɬפ
	 *  x_get_ipm()basepri򻲾Ȥ뤿ᡤbasepri⹹롥
	 */
	ldr   r1, =_kernel_int_iipm_tbl
	ldrb  r2, [r1, r3]
	ldr   r0, =iipm
	strb  r2, [r0]

	ldr   r1, =_kernel_exc_tbl   /* ϥɥ饢ɥ쥹 */
	lsls  r0, r3, #2
	ldr   r2, [r1, r0]

#ifdef LOG_INH_ENTER
	push  {r0,r2,r3}
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_inh_enter          /* log_exc_enterƤӽФ */
	pop   {r0,r2,r3}
#endif /* LOG_EXC_ENTER */

#ifdef LOG_INH_LEAVE
	mrs   r3, ipsr               /* װֹμ */
	push  { r3 }                 /* ֹ򥹥å    */
#endif /* LOG_INT_LEAVE */

	/*
	 *  ߥϥɥθƤӽФ
	 */
	mov   r0, lr
	blx   r2

#ifdef LOG_INH_LEAVE
	pop   {r0}                   /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */


/*
 *  /㳰и
 *
 *  ret_exc/ret_intϡCPU㳰/ߥϥɥ餫äľ˼¹Ԥ
 *  롼Ǥ롥
 */
ALABEL(ret_exc)
ALABEL(ret_int)
	/*
	 *  ߥå֤Ȥ롥λǤϡCPUå֤ˤϤʤʤ
	 * baseprilock_flagsaved_iipmϹʤˡ
	 *
	 *  ߥå֤ȤΤϡΥƥȤΥåȡ
	 *  褬󥿥ƥȤǤäΥ꥿򥢥ȥߥå
	 *  ˹ԤǤ롥bsepriCPUåͤˤ뤳ȤǤ⥢ȥߥ
	 *  ʥåϲǽǤ뤬ߤ꥿󤷤Ƥ⡤
	 *  basepri ƤϸʤᡤѤ뤳ȤǤʤ 
	 *  FAULTMASKϡߤΥ꥿ˤäơ'0'˥
	 *  롥
	 */
	cpsid i

	/*
	 *  ͥ٥ޥ򸵤᤹
	 */
	ldr  r1, =0xffffffff
	ldr  r2, =NVIC_CLRENA0  /* öIRQߤƶػ */
	str  r1, [r2]
	pop  {r0,r1}            /* å㳰/ȯNVIC_SETENA0(r0),SYSTIC_CONTROL_STATUS(r1)ͤ */
	ldr  r2, =NVIC_SETENA0  /* NVIC_SETENA0򸵤᤹ */
	str  r0, [r2]
	ldr  r3, =SYSTIC_CONTROL_STATUS  /* SYSTIC_CONTROL_STATUS򸵤᤹ */
	ldr  r0,[r3] 
	movs r2, #SYSTIC_TICINT
	orrs r1, r1, r2
	bics r0, r2
	orrs r0, r1
	str  r0, [r3]
	pop  {r0}               /* iipm᤹ */
	ldr  r1, =iipm
	strb r0, [r1]

	/*
	 *  ΥƥȤȽ
	 * 
	 *  ߥϥɥ¹ԤLR˥åȤEXC_RETURNåơ
	 *  MSPȤƤС褬󥿥ƥȤȽꤹ롥
	 */
	pop   {r3}                     /* lr򥹥å         */
	movs  r1, #EXC_RETURN_PSP      /* 褬PSPʤ ret_int_1  */
	tst   r3, r1
	bne   ret_int_1
	b     ret_int_2

	/*
	 *  ܤγߤνи
	 */
ALABEL(ret_int_1)
	/*
	 *  PSP夫顤EXC_RETURN(r0)ȸγͥ٥ޥ(basepri)(r1)
	 *  
	 */
	mrs   r2, psp
	adds  r2, r2, #(0x04*2)  
	msr   psp, r2

	/*
	 *  reqflgå
	 * 
	 *  ͥγߤ϶ػߤ֤Ǽ¹Ԥɬפ뤿ᡤ
	 *  FAULTMASK'1'ˤ֤Ǽ¹Ԥ롥
	 *  reqflgå˳ߤػߤΤϡreqflgå
	 *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
	 *  줿ˡ˥ǥѥåʤȤ꤬뤿
	 *  Ǥ롥
	 */
	ldr   r0, =reqflg             /* reqflgfalseʤ餽Τޤ */
	ldr   r2, [r0]
	cmp   r2, #1                  /* trueʤret_int_3           */
	beq   ret_int_3

ALABEL(ret_int_2)
	/*
	 *  ˤϳߥå֡FAULTMASKåȡˤ줿֤롥
	 *  Thread⡼ɤΥ꥿ˤ꼫ưŪ˳ߥå֤ˤʤ롥
	 *  ͥ٥ޥϳ˾֤᤹
	 */ 
	cpsie i                       /* ߤΥ꥿ǥꥢʤ᥯ꥢ */
	bx    r3                      /* ꥿ */

ALABEL(ret_int_3)
	/*
	 *  Ǥϡ褬ǤꡤPSP˥å쥸ȳ
	 *  ͥ٥ޥ(basepri)¸줿֤ˤʤäƤ롥ޤ
	 *  ץåϡHandler⡼ɡߥå֤ȤʤäƤ롥
	 *  ޤr0ˤϡreqflgΥɥ쥹r3ˤϳ߼ջlrͤ
	 *  Ƥ롥
	 */
	/*
	 *  㳰ϥɥǥѥå򤹤ݤThread⡼ɤܤ
	 *  ߡΥåե졼ơbx̿Handler⡼ɤ
	 *  󤹤롥ޤٱǥѥå⡤Ƥӳ
	 *  ݤˤϡsvc̿ǡsvc_handlerƤӽФ
	 *  åե졼ϡConfigureation and Control Register(CCR)
	 *  STKALIGN'1'ξϡ8byte˥饤󤵤롥
	 *   : DDI0403B_arm_architecture_v7m_reference_manual(P.220)
	 *  ΤᡤλΥåϳߤ㳰ȯ˺줿
	 *  åե졼फ顤8byteΥˤƤȡsvc_handler
	 *  ǥåե졼Υ饤Ȥ̵ͭγǧάǤ롥
	 *  ƥ൯ưϡưŪCCRSTKALIGNѹΤ
	 *  ػߤȤ롥
	 *  λɸΥåե졼ϡߡ㳰ȯƱǤ
	 *  뤿ᡤå(PSP)8byteˤʤäƤ롥
	 */
	movs  r1, #0                   /* reqflgfalse */
	str   r1, [r0]

	/*
	 *  CPUå֤˰ܹԤ롥
	 *
	 *  ͥδγߤػߤ褦basepriꤷ
	 *  lock_flag  saved_iipm 򹹿롥saved_iipmϡγ
	 *  ͥ٥ޥʤɽˤꤹ롥
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 *  ʤνθ塤Thread⡼ɤؤΰܹԽԤʤᡤ
	 *  å(FAULTMASK"1")ݻ롥
	 */

	/*
	 *  ͥ٥ޥ֡TIPM_ENAALLˤꤹ
	 *  ǤCPUå֤ʤΤǡsaved_iipmIIPM_ENAALLȤ롥
	 */

	/*
	 *  Thread⡼ɤذܹԤ롥
	 *
	 *  dispatchercall_texrnƤӽФϡThread⡼ɤǤɬ
	 *  פ뤿ᡤPSPå˥ߡ㳰ե졼֤ơ
	 *  Ū˳ߥϥɥ餫꥿󤹤롥
	 *  ꥿ƱFAULTMASKưŪ˥ꥢ졤ͥ
	 *  ߤĤ롥
	 */
	ldr   r0, =ret_int_4          /* PC   */
	ldr   r1, =EPSR_T             /* xPSR(TӥåȤ'1'Ǥɬפ) */
	mrs   r2, psp
	subs  r2, #(0x04*2)
	str   r1, [r2, 0x04]
	str   r0, [r2, 0x00]
	subs  r2, #(EXC_FRAME_SIZE - (4*2)) /* r0-r3,r12,lrƤꤹɬפʤ */
	msr   psp,r2                  
	bx    r3                      /* Thread⡼ɤذܹ */
    
ALABEL(ret_int_4)
	/*
	 *  嵭νˤꡤThread⡼ɤǼ¹Ԥ롥
	 *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
	 *  ǥѥåԤʤΥåɬפʤΤϡ㳰
	 *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
	 *  reqflgtrueˤ뤿Ǥ롥
	 */
	ldr   r0, =p_runtsk       /* ǥѥåԤʤǤ⡤r1p_runtsk (TCB) */
	ldr   r1, [r0]            /* äƤɬפΤǡɤ߹ */
	ldr   r0, =dspflg         
	ldr   r2, [r0]
	cmp   r2, #0x01           /* dspflgfalseʤret_int_r_1 */
	bne   ret_int_r_1     
	ldr   r0, =p_schedtsk     
	ldr   r2, [r0]
	cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
	beq   ret_int_r_1         /*                  ret_int_r_1 */
	mov  r0, r8
	mov  r1, r9
	mov  r2, r10
	mov  r3, r11
	push {r0-r7}
	ldr   r2, =p_runtsk
	ldr   r1, [r2]
	mov   r0, sp
	str   r0, [r1,#TCB_sp]    /* å¸ */
	ldr   r2, =ret_int_r      /* ¹ԺƳϤ¸   */
	str   r2, [r1,#TCB_pc]
	b     dispatcher          /* ǥѥå */

/*
 * ߤˤץꥨץȤ줿ؤΥ꥿
 *
 * Thread⡼ɤǡǥѥåߤνиƤӽФ롥
 * ߤˤץꥨץȤ줿إ꥿󤹤ˤϡä
 * Handler⡼ɤ˰ܹԤPC0xfffffffdƥ꥿󤹤ɬ
 * 롥ΤᡤSVCˤꡤSVCϥɥƤӽФHandler⡼
 * ɤذܹԤ롥
 */
	ATHUMB(ret_int_r)
	AGLOBAL(ret_int_r)
ALABEL(ret_int_r)
	pop  {r0-r7}
	mov  r8,  r0
	mov  r9,  r1
	mov  r10, r2
	mov  r11, r3
ALABEL(ret_int_r_1)
	/*
	 *  enatextrueǡtexptn0ǤʤС㳰롼
	 *  ƤӽФ
	 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
	 */
	ldr   r2, =p_runtsk
	ldr   r1, [r2]
	ldrb  r0, [r1,#TCB_enatex]
	movs  r2, #TCB_enatex_mask
	tst   r0, r2
	beq   ret_int_r_2           /* enatex  false ʤ ret_int_r_2 */
	ldr   r0, [r1,#TCB_texptn]  /* texptn  0 ʤ꥿     */
	cmp   r0, #0x00
	beq   ret_int_r_2
	ldr   r1, =ipmflg             /* ipmflg false ʤ꥿  */
	ldr   r0, [r1]
	cmp   r0, #0x00
	beq   ret_int_r_2 
	bl    call_texrtn           /* 㳰롼θƤӽФ */
ALABEL(ret_int_r_2)
	ldr   r0, =NVIC_ICSR
	ldr   r1, =NVIC_PENDSVSET
	str   r1, [r0]
	cpsie i                     /* PRIMASK򥯥ꥢPendSVCդ */                
1:                              /* ˤʤ */
	b  1b

/*
 *  SVCϥɥ
 */
	ATHUMB(svc_handler)
	AGLOBAL(svc_handler)
ALABEL(svc_handler)
1:
	b  1b

/*
 *  PendSVCϥɥ
 */
	ATHUMB(pendsvc_handler)
	AGLOBAL(pendsvc_handler)
ALABEL(pendsvc_handler)
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
	 *  롥
	 */
	mrs   r0, psp
	adds  r0, #EXC_FRAME_SIZE     /* åΤƤ   */
	msr   psp, r0
	movs  r0, #0
	bx    lr                      /* ꥿     */

/*
 *  ǥѥåư
 */
	ATHUMB(start_dispatch)
	AGLOBAL(start_dispatch)
ALABEL(start_dispatch)
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  core_initializeǡlock_flagtrueˡsaved_iipmIIPM_ENAALL
	 *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */
	ldr   r0,=istkpt              /* MSP   */
	ldr   r1,[r0]                 /* start_dispatchƤӽФ˸ƤӽФѤ */
	msr   msp, r1                 /* ѤƤ뤿             */
	movs  r0, #CONTROL_PSP        /* PSPͭ  */
	msr   control, r0
	isb                           /* control ɬ */

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
	ATHUMB(exit_and_dispatch)
	AGLOBAL(exit_and_dispatch)
ALABEL(exit_and_dispatch)
	/* ǥѥåΡdispatcherˤ */ 


/*
 *  ǥѥå
 */
ALABEL(dispatcher)
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥
	 *
	 *  ʤThread⡼ɡlock_flagtruedisdspfalsedspflg
	 *  truesaved_iipmIIPM_ENAALLȤʤäƤ롥¹ԺƳϤؤ⤳
	 *  ξ֤Τޤʬ롥
	 */
#ifdef LOG_DSP_ENTER
	ldr   r1, =p_runtsk     /* p_runtskѥ᡼ */
	ldr   r0, [r1]        
	bl    log_dsp_enter
#endif /* LOG_DSP_ENTER */
ALABEL(dispatcher_0)
	ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
	ldr   r1, [r0]
	ldr   r2, =p_runtsk   
	str   r1, [r2]        
	cmp   r1, #0x00         /* p_runtskNULLʤdispatcher_1 */
	beq   dispatcher_1  
	ldr   r2, [r1,#TCB_sp]  /* å */
	mov   sp, r2
#ifdef LOG_DSP_LEAVE
	mov   r0, r1            /* p_runtskѥ᡼ */
	mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
	bl    log_dsp_leave
	mov   r1, r4
#endif /* LOG_DSP_LEAVE */
	ldr   r2, [r1,#TCB_pc]  /* ¹ԺƳϤ   */    
	mov   pc, r2
ALABEL(dispatcher_1)
	/*
	 * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 * 򤹤
	 */
	movs  r0, #CONTROL_MSP  /* MSPͭ  */
	msr   control, r0       
	isb                     /* control ɬ */
	movs  r4, #0            /* r4 <- '0' */
	ldr   r6, =reqflg       /* r6 <- reqflg */
ALABEL(dispatcher_2)
	/*
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
	 *
	 *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
	 *  ߽ˤɤΥåȤȤβȡ
	 *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ롥
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *  ARM-MǤϡPRIMASK򥻥åȤ֤WFIƤӽФȤǼ¸Ǥ롥
	 *  ξ֤ǳߤȡߤϼ¹Ԥ줺WFI꥿
	 *  뤳ȤˤʤΤǡöߤĤƳߥϥɥ¹Ԥ롥
	 *
	 *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
	 *  ݤưͤ˹פʤʤ롥
	 *
	 *  åȤˤäƤϡϥ⡼˰ܹԤ뤿ᡤɸˡ
	 *  ۤʤ礬ɬפʾ礬롥
	 *  Τ褦ʥåȤǤϡåȰ¸ˤơTOPPERS_CUSTOM_IDLE
	 *  ֥ޥȤơtoppers_asm_custom_idle Ѱ
	 *  Ф褤
	 *
	 *  ʤtoppers_asm_custom_idle εҤˤäƤϡΥ쥸
	 *  toppers_asm_custom_idleǻѤ뤿ᡤ
	 *  toppers_asm_custom_idle ǻѤϡ¸뤳ȡ
	 *  Υ쥸 Calee saved 쥸Ǥ뤿ᡤ 
	 *  toppers_asm_custom_idle ȤƴؿƤӽФ򤷤ϡƤӽФ
	 *  ؿǼưŪ¸뤿ᡤ֥٥Ǥ¸ɬ
	 *  פʤ
	 *
	 *  쥸 : 
	 *   r4      : '0'
	 *   r5      : 'IIPM_LOCK'
	 *   r6      : reqflgΥɥ쥹
	 *   r7      : lock_flgΥɥ쥹
	 *   sp      : 󥿥ƥѤΥåƬɥ쥹(msp)
	 */
#ifdef TOPPERS_CUSTOM_IDLE
	toppers_asm_custom_idle
#else
	wfi
	cpsie i               /* PRIMASK 򥯥ꥢʳߤդ */
	cpsid i               /* PRIMASK 򥻥å */
#endif /* TOPPERS_CUSTOM_IDLE */

	ldr   r0, [r6]        /* reqflgfalseʤdispatcher_2 */
	cmp   r0, #0
	beq   dispatcher_2
	str   r4, [r6]        /* reqflgfalse */

	/*
	 *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
	 *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
	 *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
	 *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
	 *  Ф褤
	 */
	movs  r0, #CONTROL_PSP  /* PSPͭ  */ 
	msr   control, r0      
	isb                     /* control ɬ */
	b     dispatcher_0

/*
 *  ͥνλθƽФ
 *
 *  å󥿥ƥѤڤؤ
 *  
 */
	ATHUMB(call_exit_kernel)
	AGLOBAL(call_exit_kernel)
ALABEL(call_exit_kernel)
	movs  r0, #CONTROL_MSP
	msr   control, r0       /* MSPͭ  */
	isb                     /* control ɬ */
	ldr   r0, =exit_kernel  /* ͥνλƤ */
	bx    r0

/*
 *  ư
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 *
 */ 
	ATHUMB(start_r)
	AGLOBAL(start_r)
ALABEL(start_r)
	movs  r0, #0
	cpsie i                                 /* ߵ   */
	ldr   r0, =ext_tsk                      /*  */
	mov   lr, r0
	ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
	ldr   r0, [r2, #TINIB_exinf]            /* exinf쥸r0  */
	ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
	bx    r1

/*
 *  Ԥ
 */
	ABALIGN(4)
	ATEXT
	ATHUMB(sil_dly_nse)
	AGLOBAL(sil_dly_nse)
ALABEL(sil_dly_nse)
	ldr   r1, =SIL_DLY_TIM1
	subs  r0, r0, r1
	cmp   r0, #0
	bgt   sil_dly_nse1
	bx    lr
ALABEL(sil_dly_nse1)
	ldr   r1, =SIL_DLY_TIM2
ALABEL(sil_dly_nse2)
	subs  r0, r0, r1
	cmp   r0, #0
	bgt   sil_dly_nse2
	bx    lr

